function dateTimeHeader() {
    var req = new XMLHttpRequest();
    req.open('HEAD', document.location, false);
    req.send(null);
    var headers = req.getResponseHeader('Date');
    document.getElementById('datetimeserver').innerHTML = headers;
}

function dateTimeClient() {
    var d = new Date,
        currentDate = ('0' + d.getDate()).slice(-2) + '/'
            + ('0' + (d.getMonth() + 1)).slice(-2) + '/' 
            + d.getFullYear() + ' '
            + ('0' + d.getHours()).slice(-2)  + ':'
            + ('0' + d.getMinutes()).slice(-2) + ':'
            + ('0' + d.getSeconds()).slice(-2),
        dformat = [d.getFullYear(),
        d.getMonth() + 1,
        d.getDate()].join('-') + 'T' +
            [d.getHours(),
            d.getMinutes(),
            d.getSeconds()].join(':');

    var dataclient = document.getElementById('datetimeclientvalue');
    dataclient.setAttribute('value', dformat);
    document.getElementById('datetimeclient').innerHTML = currentDate;
}

$(document).ready(function () {
    $('form#reset').submit(function (e) {
        let result = window.confirm("The Factory Reset will erase all your applications, logs, codesys users and groups, files stored inside the PLC, configuration data and then will restart the product. Do you really want to apply the Factory Reset?");
        let text;
        console.log(result);
        if (result == null || result == "") {
            text = "User cancelled the prompt.";
            e.preventDefault();
        } else {
            text = "User select restart: " + result;
            return true;
        }
        console.log(text);
    });

    dateTimeHeader();
    dateTimeClient();

    setInterval(function () {
        dateTimeHeader();
        dateTimeClient();
    }, 500);

});

$(document).ready(function () {
    $('form#rebootplc').submit(function (e) {
        let result = window.confirm("Are you sure you want to proceed with rebooting the product?");
        let text;
        console.log(result);
        if (result == null || result == "") {
            text = "User cancelled the prompt.";
            e.preventDefault();
        } else {
            text = "User select restart: " + result;
            return true;
        }
        console.log(text);
    });

    dateTimeHeader();
    dateTimeClient();

    setInterval(function () {
        dateTimeHeader();
        dateTimeClient();
    }, 500);

});

// funcao para requisitar campos de login do FTP
fetch('/ftpcfg.json')
    .then(function (result) {
        return result.json();
    })
    .then(function (data) {
        const json = JSON.stringify(data);
        const obj = JSON.parse(json);
        // console.log(obj);

        document.getElementById('login-username').setAttribute('value', obj.FTP_LOGIN);
        document.getElementById('login-password').setAttribute('value', obj.FTP_PASS);

        // var FTP = document.getElementsByName("FTP");    // pegar todos os radios
        // for (var i = 0; i < FTP.length; i++) {
        //     if (i = obj.FTP_TYPE) {
        //         document.getElementById(FTP[i].id).setAttribute('checked', '');
        //     }
        //     else {
        //         document.getElementById(FTP[i].id).removeAttribute('checked');
        //         document.getElementById(FTP[i].id).required = false;
        //     }
        // }

        if (!obj.FTP_TYPE) {

            document.getElementById('FTP-DISABLE').setAttribute('checked', '');
            document.getElementById('FTP-FTP').removeAttribute('checked');
            document.getElementById('FTP-FTP').required = false;
            document.getElementById('FTP-FTPS').removeAttribute('checked');
            document.getElementById('FTP-FTPS').required = false;
        }
        else {
            if (obj.FTP_TYPE == 1) {
                document.getElementById('FTP-FTP').setAttribute('checked', '');
                document.getElementById('FTP-DISABLE').removeAttribute('checked');
                document.getElementById('FTP-DISABLE').required = false;
                document.getElementById('FTP-FTPS').removeAttribute('checked');
                document.getElementById('FTP-FTPS').required = false;
            }
            if (obj.FTP_TYPE == 2) {
                document.getElementById('FTP-FTPS').setAttribute('checked', '');
                document.getElementById('FTP-DISABLE').removeAttribute('checked');
                document.getElementById('FTP-DISABLE').required = false;
                document.getElementById('FTP-FTP').removeAttribute('checked');
                document.getElementById('FTP-FTP').required = false;
            }
        }
        if (obj.FTP_USB == 1) {
            document.getElementById('FTP-usb').setAttribute('checked', '');
            document.getElementById('FTP-usb').disabled = false;
        }
        if (obj.FTP_USB == 0) {
            document.getElementById('FTP-usb').removeAttribute('checked');
            document.getElementById('FTP-usb').disabled = false;
        }
        if (obj.FTP_SD == 1) {
            document.getElementById('FTP-sdcard').setAttribute('checked', '');
            document.getElementById('FTP-sdcard').disabled = false;
        }
        if (obj.FTP_SD == 0) {
            document.getElementById('FTP-sdcard').removeAttribute('checked');
            document.getElementById('FTP-sdcard').disabled = false;
        }
    })
    .catch(function (err) {
        console.log("FTP json file not received");
        console.log(err);
    });

// Fazendo o fetch para obter o JSON
fetch('/networks.json')
    .then(response => {
        if (!response.ok) {
            throw new Error(`Requesition: ${response.status}`);
        }
        return response.json();
    })
    .then(data => {
        if ('IP2' in data) {
            document.getElementById('ETH-2').disabled = false;
        }
        else {
            document.getElementById('ETH-2').disabled = true;
        }
    })
    .catch(error => {
        console.log("NETWORK json file not received");
        console.log(error);
    });

// funcao para fazer a troca para campo de texto e mostrar senha (PASSWORD)
function TooglePasswordDisplay() {
    var x = document.getElementById("login-password");
    if (x.type === "password") {
        x.type = "text";
    } else {
        x.type = "password";
    }
}

function toggleFields() {
    // Verifica se o modo DHCP está selecionado
    const isDhcp = document.getElementById('ETH-Dhcp').checked;

    // Referências aos campos
    const ipField = document.getElementById('IP');
    const netmaskField = document.getElementById('NETMASK');

    // Habilita/desabilita os campos
    ipField.disabled = isDhcp;
    netmaskField.disabled = isDhcp;

    // Placeholders
    ipField.placeholder = isDhcp ? 'dhcp' : '192.168.1.10';
    netmaskField.placeholder = isDhcp ? 'dhcp' : '255.255.255.0';

    // Limpa os valores se DHCP estiver selecionado
    if (isDhcp) {
        ipField.value = '';
        netmaskField.value = '';
    }

}

// funcao para fazer a troca para campo de texto e mostrar senha (CHANGE PASSWORD)
function ToogleChangePasswordDisplay() {
    var x = document.getElementById("login-pass");
    if (x.type === "password") {
        x.type = "text";
    } else {
        x.type = "password";
    }
}

function getCookiesMap(cookiesString) {
    return cookiesString.split(";")
        .map(function (cookieString) {
            return cookieString.trim().split("=");
        })
        .reduce(function (acc, curr) {
            acc[curr[0]] = curr[1];
            return acc;
        }, {});
}

var cookies = getCookiesMap(document.cookie);
console.log(cookies);

if (cookies["FTP_passw"] != null) {
    if (cookies["FTP_passw"] == "True") {
        window.alert("The FTP password has been successfully changed!");
    }
    else if (cookies["FTP_passw"] == "False") {
        window.alert("An error occurred while changing the FTP server password!");
    }
}

if (cookies["TemporaryIP"] != 'None') {
    console.log("Cookies: ", cookies["TemporaryIP"]);
    if (cookies["TemporaryIP"] == 0) {
        window.alert("The current IP settings are temporary.\n\nAny network configurations set through the Webpage will be overwritten whenever the CODESYS application starts.\n\nTo ensure the desired IP configuration remains consistent, make the changes directly within the CODESYS application.");
    }
    else if (cookies["TemporaryIP"] == -1) {
        window.alert("Error: NULL pointer passed");
    }
    else if (cookies["TemporaryIP"] == -2) {
        window.alert("Error: eth not valid");
    }
    else if (cookies["TemporaryIP"] == -3) {
        window.alert("Error: Invalid eth mode, use 0 for static or 1 for dynamic");
    }
    else if (cookies["TemporaryIP"] == -4) {
        window.alert("Error: Dynamic mode set but IP or netmask != Not_Used");
    }
    else if (cookies["TemporaryIP"] == -11) {
        window.alert("Error: Invalid caracter found! Use only numbers (0-9) and dots (.)");
    }
    else if (cookies["TemporaryIP"] == -12) {
        window.alert("Error: Wrong number of IP fields. (Typed IP =");
    }
    else if (cookies["TemporaryIP"] == -13) {
        window.alert("Error: More than 3 number(s) in an IP field");
    }
    else if (cookies["TemporaryIP"] == -14) {
        window.alert("Error: Put at least one number(s) in all IP fields.");
    }
    else if (cookies["TemporaryIP"] == -15) {
        window.alert("Error: IP field value out of range (0-255).");
    }
    else if (cookies["TemporaryIP"] == -16) {
        window.alert("Error: IP either not set or null pointer");
    }
    else if (cookies["TemporaryIP"] == -21) {
        window.alert("Error: Invalid caracter found! Use only numbers (0-9) and dots (.)");
    }
    else if (cookies["TemporaryIP"] == -22) {
        window.alert("Error: Wrong number of netmask fields.");
    }
    else if (cookies["TemporaryIP"] == -23) {
        window.alert("Error: More than 3 number(s) in a netmask field");
    }
    else if (cookies["TemporaryIP"] == -24) {
        window.alert("Error: Put at least one number(s) in all netmask fields.");
    }
    else if (cookies["TemporaryIP"] == -25) {
        window.alert("Error: Netmask field value out of range (0-255).");
    }
    else if (cookies["TemporaryIP"] == -26) {
        window.alert("Error: Netmask either not set or null pointer");
    }
    else if (cookies["TemporaryIP"] == -27) {
        window.alert("Error: You cannot set both ETHs at the same network.");
    }
    else {
        window.alert("Temporary IP update error.");
        console.log("Temporary IP update error!");
    }
    window.location.replace("/configuration.html");
    
    document.cookie = "TemporaryIP=None;";
}

// limitando para apenas letras e numeros o input de senha
$('#login-pass').bind('input', function () {
    var c = this.selectionStart,
        r = /[^a-z0-9]/gi,
        v = $(this).val();

    if (r.test(v)) {
        $(this).val(v.replace(r, ''));
        document.getElementById("notallowed").innerHTML = 'Not allowed: ' + v.slice(-1);
        c--; // retorna um caractere
    }

    else {
        $(this).val(v.replace(r, ''));
        document.getElementById("notallowed").innerHTML = '';
    }

    this.setSelectionRange(c, c);
});


if (window.history.replaceState) {
    window.history.replaceState(null, null, window.location.href);
}