import logging
from webserver.login import Session
from webserver.httpserver import PLCServer
logging.basicConfig(format='[%(asctime)s] - %(message)s', level=logging.INFO)
from http.server import ThreadingHTTPServer
import os
# import ssl
# openssl req -new -x509 -keyout key.pem -out server.pem -days 365 -nodes


# alterando caminho para acessar somente 
# arquivos relacionados ao serviço
# TODO deve ser alterado para utilizar doker
os.chdir(os.path.dirname(os.path.realpath(__file__)))
PORT = 80
# PORT = 4443

def main():
    # print(*arg, **kwarg)
    sessions = Session()
    sessions.empty_sessions()
    try:
        with ThreadingHTTPServer(('', PORT), PLCServer) as server:
            logging.info('Webserver running at: {%d} PORT', PORT)
            # server.socket = ssl.wrap_socket(server.socket, certfile='./server.pem', server_side=True)
            server.serve_forever()
    except KeyboardInterrupt:
        logging.warning("You pressed ^C, ending...")


if __name__ == "__main__":
    main()