#!/bin/bash
                                                  
#-------------------------------------------------------------
# SCRIPT PARA ALTERAR SENHA FTP
#
# - Pega a nova senha do arquivo Json
# - Confere para um  
#
# script localizado em: /opt/weg/scripts/ftp/ 
#
# Version: 1.2
#
#-------------------------------------------------------------


#-------------------------------------------------------
# Pega a nova senha do arquivo .json
#-------------------------------------------------------

Error=0
FTP_PASS=$(grep -oP '(?<="FTP_PASS": ")[^ ]*(?=")' /etc/weg/ftp/ftpcfg.json)
#ftp_login=$(grep -oP '(?<="FTP_LOGIN": ")[^ ]*(?=")' /etc/weg/ftp/ftpcfg.json)   
ftp_login="wegftp"

#-------------------------------------------------------
# Confere a senha e login diferente de nulo se for 
# nulo recria o arquivo Json
#-------------------------------------------------------

if [[ -z $FTP_PASS || -z $ftp_login ]];
then
    echo "plclogFTPpasswd: $0 FAULT $LINENO" | systemd-cat;
    plctools --ftp init;
    Error=1
else
    #-------------------------------------------------------
    # Altera a senha do usuario FTP
    #   em caso de erro retorna para a senha padrão wegftp
    #-------------------------------------------------------
    echo -e "$FTP_PASS\n$FTP_PASS" | passwd $ftp_login
        if [ $? -ne 0 ]; 
        then 
            echo "plclogFTPpasswd: $0 FAULT $LINENO" | systemd-cat; 
            echo -e "wegftp\nwegftp" | passwd $ftp_login;
            plctools --ftp pass wegftp;
            Error=2  
        fi  
    sleep 0.5

    #-------------------------------------------------------
    # Reinicia o FTP
    #-------------------------------------------------------
    /opt/weg/scripts/ftp/initFTP.sh &
         if [ $? -ne 0 ]; then echo "plclogFTP: $0 FAULT $LINENO" | systemd-cat; fi
fi
exit $Error
